#include <sys/types.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <caml/mlvalues.h>
#include <caml/alloc.h>
#include <caml/memory.h>
#include <caml/custom.h>

CAMLprim value c_columns(value u)
{
    CAMLparam1(u);
    struct winsize ws;

    if ( isatty(0) && !ioctl(0, TIOCGWINSZ, &ws) )
      CAMLreturn(Val_int(ws.ws_col));
    else
      CAMLreturn(Val_int(80));
}

CAMLprim value c_rows(value u)
{
    CAMLparam1(u);
    struct winsize ws;

    ioctl(1, TIOCGWINSZ, &ws);
    CAMLreturn(Val_int(ws.ws_row));
}
